// WinFinderCtl.h : Declaration of the CWinFinderCtrl OLE control class.

/////////////////////////////////////////////////////////////////////////////
// CWinFinderCtrl : See WinFinderCtl.cpp for implementation.

typedef int (*WINFINDERCALLBACK)(HWND);

class CWinFinderCtrl : public COleControl
{
	DECLARE_DYNCREATE(CWinFinderCtrl)

// Constructor
public:
	CWinFinderCtrl();

	int (*m_pfnWindowSelectedCallback)(HWND);

// Overrides

	// Drawing function
	virtual void OnDraw(
				CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

	// Persistence
	virtual void DoPropExchange(CPropExchange* pPX);

	// Reset control state
	virtual void OnResetState();

// Implementation
protected:
	~CWinFinderCtrl();

	BEGIN_OLEFACTORY(CWinFinderCtrl)        // Class factory and guid
		virtual BOOL VerifyUserLicense();
		virtual BOOL GetLicenseKey(DWORD, BSTR FAR*);
	END_OLEFACTORY(CWinFinderCtrl)

	DECLARE_OLETYPELIB(CWinFinderCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CWinFinderCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CWinFinderCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CWinFinderCtrl)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg LRESULT OnSetWFCallback(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CWinFinderCtrl)
	BOOL m_bDragging;
	afx_msg void OnDraggingChanged();
	long m_targetWindow;
	afx_msg void OnTargetWindowChanged();
	afx_msg OLE_HANDLE GetHwnd();
	afx_msg void SetHwnd(OLE_HANDLE nNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CWinFinderCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CWinFinderCtrl)
	dispidDragging = 1L,
	dispidTargetWindow = 2L,
	dispidSetCallback = 3L,
	//}}AFX_DISP_ID
	};
};
